Index: src/molecule_fragmentation.cpp
===================================================================
--- src/molecule_fragmentation.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/molecule_fragmentation.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -1455,5 +1459,5 @@
   atom *Walker = NULL;
 
-  Log() << Verbose(0) << "Combining the lists of all orders per order and finally into a single one." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Combining the lists of all orders per order and finally into a single one." << endl);
   if (FragmentList == NULL) {
     FragmentList = new Graph;
@@ -1488,5 +1492,5 @@
 void FreeAllOrdersList(Graph ***FragmentLowerOrdersList, KeyStack &RootStack, molecule *mol)
 {
-  Log() << Verbose(1) << "Free'ing the lists of all orders per order." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Free'ing the lists of all orders per order." << endl);
   int RootNr = 0;
   int RootKeyNr = 0;
@@ -1541,5 +1545,5 @@
   struct UniqueFragments FragmentSearch;
 
-  Log() << Verbose(0) << "Begin of FragmentBOSSANOVA." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Begin of FragmentBOSSANOVA." << endl);
 
   // FragmentLowerOrdersList is a 2D-array of pointer to MoleculeListClass objects, one dimension represents the ANOVA expansion of a single order (i.e. 5)
@@ -1591,6 +1595,6 @@
 
       // create top order where nothing is reduced
-      Log() << Verbose(0) << "==============================================================================================================" << endl;
-      Log() << Verbose(0) << "Creating KeySets of Bond Order " << Order << " for " << *Walker << ", " << (RootStack.size()-RootNr) << " Roots remaining." << endl; // , NumLevels is " << NumLevels << "
+      DoLog(0) && (Log() << Verbose(0) << "==============================================================================================================" << endl);
+      DoLog(0) && (Log() << Verbose(0) << "Creating KeySets of Bond Order " << Order << " for " << *Walker << ", " << (RootStack.size()-RootNr) << " Roots remaining." << endl); // , NumLevels is " << NumLevels << "
 
       // Create list of Graphs of current Bond Order (i.e. F_{ij})
@@ -1602,5 +1606,5 @@
 
       // output resulting number
-      Log() << Verbose(1) << "Number of resulting KeySets is: " << NumMoleculesOfOrder[RootNr] << "." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Number of resulting KeySets is: " << NumMoleculesOfOrder[RootNr] << "." << endl);
       if (NumMoleculesOfOrder[RootNr] != 0) {
         NumMolecules = 0;
@@ -1619,7 +1623,7 @@
     }
   }
-  Log() << Verbose(0) << "==============================================================================================================" << endl;
-  Log() << Verbose(1) << "Total number of resulting molecules is: " << TotalNumMolecules << "." << endl;
-  Log() << Verbose(0) << "==============================================================================================================" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "==============================================================================================================" << endl);
+  DoLog(1) && (Log() << Verbose(1) << "Total number of resulting molecules is: " << TotalNumMolecules << "." << endl);
+  DoLog(0) && (Log() << Verbose(0) << "==============================================================================================================" << endl);
 
   // cleanup FragmentSearch structure
@@ -1639,5 +1643,5 @@
   Free(&NumMoleculesOfOrder);
 
-  Log() << Verbose(0) << "End of FragmentBOSSANOVA." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "End of FragmentBOSSANOVA." << endl);
 };
 
@@ -1654,4 +1658,5 @@
   atom *Walker = NULL;
   atom *OtherWalker = NULL;
+  double * const cell_size = World::getInstance().getDomain();
   double *matrix = ReturnFullMatrixforSymmetric(cell_size);
   enum Shading *ColorList = NULL;
@@ -1662,5 +1667,5 @@
   bool flag = true;
 
-  Log() << Verbose(2) << "Begin of ScanForPeriodicCorrection." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Begin of ScanForPeriodicCorrection." << endl);
 
   ColorList = Calloc<enum Shading>(AtomCount, "molecule::ScanForPeriodicCorrection: *ColorList");
@@ -1668,5 +1673,5 @@
     // remove bonds that are beyond bonddistance
     for(int i=NDIM;i--;)
-      Translationvector.x[i] = 0.;
+      Translationvector[i] = 0.;
     // scan all bonds
     Binder = first;
@@ -1675,10 +1680,10 @@
       Binder = Binder->next;
       for (int i=NDIM;i--;) {
-        tmp = fabs(Binder->leftatom->x.x[i] - Binder->rightatom->x.x[i]);
+        tmp = fabs(Binder->leftatom->x[i] - Binder->rightatom->x[i]);
         //Log() << Verbose(3) << "Checking " << i << "th distance of " << *Binder->leftatom << " to " << *Binder->rightatom << ": " << tmp << "." << endl;
         if (tmp > BondDistance) {
           OtherBinder = Binder->next; // note down binding partner for later re-insertion
           unlink(Binder);   // unlink bond
-          Log() << Verbose(2) << "Correcting at bond " << *Binder << "." << endl;
+          DoLog(2) && (Log() << Verbose(2) << "Correcting at bond " << *Binder << "." << endl);
           flag = true;
           break;
@@ -1689,12 +1694,11 @@
       // create translation vector from their periodically modified distance
       for (int i=NDIM;i--;) {
-        tmp = Binder->leftatom->x.x[i] - Binder->rightatom->x.x[i];
+        tmp = Binder->leftatom->x[i] - Binder->rightatom->x[i];
         if (fabs(tmp) > BondDistance)
-          Translationvector.x[i] = (tmp < 0) ? +1. : -1.;
+          Translationvector[i] = (tmp < 0) ? +1. : -1.;
       }
       Translationvector.MatrixMultiplication(matrix);
       //Log() << Verbose(3) << "Translation vector is ";
-      Translationvector.Output();
-      Log() << Verbose(0) << endl;
+      Log() << Verbose(0) << Translationvector <<  endl;
       // apply to all atoms of first component via BFS
       for (int i=AtomCount;i--;)
@@ -1705,5 +1709,5 @@
         //Log() << Verbose (3) << "Current Walker is: " << *Walker << "." << endl;
         ColorList[Walker->nr] = black;    // mark as explored
-        Walker->x.AddVector(&Translationvector); // translate
+        Walker->x += Translationvector; // translate
         for (BondList::const_iterator Runner = Walker->ListOfBonds.begin(); Runner != Walker->ListOfBonds.end(); (++Runner)) {
           if ((*Runner) != Binder) {
@@ -1718,5 +1722,5 @@
       link(Binder, OtherBinder);
     } else {
-      Log() << Verbose(3) << "No corrections for this fragment." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "No corrections for this fragment." << endl);
     }
     //delete(CompStack);
@@ -1727,4 +1731,4 @@
   Free(&ColorList);
   Free(&matrix);
-  Log() << Verbose(2) << "End of ScanForPeriodicCorrection." << endl;
-};
+  DoLog(2) && (Log() << Verbose(2) << "End of ScanForPeriodicCorrection." << endl);
+};
Index: src/molecule_geometry.cpp
===================================================================
--- src/molecule_geometry.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/molecule_geometry.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -15,4 +15,5 @@
 #include "memoryallocator.hpp"
 #include "molecule.hpp"
+#include "World.hpp"
 
 /************************************* Functions for class molecule *********************************/
@@ -26,9 +27,10 @@
   bool status = true;
   const Vector *Center = DetermineCenterOfAll();
+  double * const cell_size = World::getInstance().getDomain();
   double *M = ReturnFullMatrixforSymmetric(cell_size);
   double *Minv = InverseMatrix(M);
 
   // go through all atoms
-  ActOnAllVectors( &Vector::SubtractVector, Center);
+  ActOnAllVectors( &Vector::SubtractVector, *Center);
   ActOnAllVectors( &Vector::WrapPeriodically, (const double *)M, (const double *)Minv);
 
@@ -46,4 +48,5 @@
 {
   bool status = true;
+  double * const cell_size = World::getInstance().getDomain();
   double *M = ReturnFullMatrixforSymmetric(cell_size);
   double *Minv = InverseMatrix(M);
@@ -69,6 +72,6 @@
   if (ptr != end) {   //list not empty?
     for (int i=NDIM;i--;) {
-      max->x[i] = ptr->x.x[i];
-      min->x[i] = ptr->x.x[i];
+      max->at(i) = ptr->x[i];
+      min->at(i) = ptr->x[i];
     }
     while (ptr->next != end) {  // continue with second if present
@@ -76,6 +79,6 @@
       //ptr->Output(1,1,out);
       for (int i=NDIM;i--;) {
-        max->x[i] = (max->x[i] < ptr->x.x[i]) ? ptr->x.x[i] : max->x[i];
-        min->x[i] = (min->x[i] > ptr->x.x[i]) ? ptr->x.x[i] : min->x[i];
+        max->at(i) = (max->at(i) < ptr->x[i]) ? ptr->x[i] : max->at(i);
+        min->at(i) = (min->at(i) > ptr->x[i]) ? ptr->x[i] : min->at(i);
       }
     }
@@ -86,5 +89,5 @@
 //    Log() << Verbose(0) << endl;
     min->Scale(-1.);
-    max->AddVector(min);
+    (*max) += (*min);
     Translate(min);
     Center.Zero();
@@ -109,5 +112,5 @@
       ptr = ptr->next;
       Num++;
-      Center.AddVector(&ptr->x);
+      Center += ptr->x;
     }
     Center.Scale(-1./Num); // divide through total number (and sign for direction)
@@ -133,6 +136,6 @@
       ptr = ptr->next;
       Num += 1.;
-      tmp.CopyVector(&ptr->x);
-      a->AddVector(&tmp);
+      tmp = ptr->x;
+      (*a) += tmp;
     }
     a->Scale(1./Num); // divide through total mass (and sign for direction)
@@ -158,7 +161,6 @@
       ptr = ptr->next;
       Num += ptr->type->mass;
-      tmp.CopyVector(&ptr->x);
-      tmp.Scale(ptr->type->mass);  // scale by mass
-      a->AddVector(&tmp);
+      tmp = ptr->type->mass * ptr->x;
+      (*a) += tmp;
     }
     a->Scale(-1./Num); // divide through total mass (and sign for direction)
@@ -186,5 +188,5 @@
 void molecule::CenterAtVector(Vector *newcenter)
 {
-  Center.CopyVector(newcenter);
+  Center = *newcenter;
 };
 
@@ -192,4 +194,9 @@
 /** Scales all atoms by \a *factor.
  * \param *factor pointer to scaling factor
+ *
+ * TODO: Is this realy what is meant, i.e.
+ * x=(x[0]*factor[0],x[1]*factor[1],x[2]*factor[2]) (current impl)
+ * or rather
+ * x=(**factor) * x (as suggested by comment)
  */
 void molecule::Scale(const double ** const factor)
@@ -200,6 +207,6 @@
     ptr = ptr->next;
     for (int j=0;j<MDSteps;j++)
-      ptr->Trajectory.R.at(j).Scale(factor);
-    ptr->x.Scale(factor);
+      ptr->Trajectory.R.at(j).ScaleAll(*factor);
+    ptr->x.ScaleAll(*factor);
   }
 };
@@ -215,6 +222,6 @@
     ptr = ptr->next;
     for (int j=0;j<MDSteps;j++)
-      ptr->Trajectory.R.at(j).Translate(trans);
-    ptr->x.Translate(trans);
+      ptr->Trajectory.R.at(j) += (*trans);
+    ptr->x += (*trans);
   }
 };
@@ -226,9 +233,10 @@
 void molecule::TranslatePeriodically(const Vector *trans)
 {
+  double * const cell_size = World::getInstance().getDomain();
   double *M = ReturnFullMatrixforSymmetric(cell_size);
   double *Minv = InverseMatrix(M);
 
   // go through all atoms
-  ActOnAllVectors( &Vector::SubtractVector, trans);
+  ActOnAllVectors( &Vector::SubtractVector, *trans);
   ActOnAllVectors( &Vector::WrapPeriodically, (const double *)M, (const double *)Minv);
 
@@ -243,5 +251,5 @@
 void molecule::Mirror(const Vector *n)
 {
-  ActOnAllVectors( &Vector::Mirror, n );
+  ActOnAllVectors( &Vector::Mirror, *n );
 };
 
@@ -252,4 +260,5 @@
 {
   atom *Walker = start;
+  double * const cell_size = World::getInstance().getDomain();
   double *matrix = ReturnFullMatrixforSymmetric(cell_size);
   double *inversematrix = InverseMatrix(cell_size);
@@ -266,5 +275,5 @@
       if (Walker->type->Z != 1) {
 #endif
-        Testvector.CopyVector(&Walker->x);
+        Testvector = Walker->x;
         Testvector.MatrixMultiplication(inversematrix);
         Translationvector.Zero();
@@ -272,33 +281,29 @@
          if (Walker->nr < (*Runner)->GetOtherAtom(Walker)->nr) // otherwise we shift one to, the other fro and gain nothing
             for (int j=0;j<NDIM;j++) {
-              tmp = Walker->x.x[j] - (*Runner)->GetOtherAtom(Walker)->x.x[j];
+              tmp = Walker->x[j] - (*Runner)->GetOtherAtom(Walker)->x[j];
               if ((fabs(tmp)) > BondDistance) {
                 flag = false;
-                Log() << Verbose(0) << "Hit: atom " << Walker->Name << " in bond " << *(*Runner) << " has to be shifted due to " << tmp << "." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "Hit: atom " << Walker->Name << " in bond " << *(*Runner) << " has to be shifted due to " << tmp << "." << endl);
                 if (tmp > 0)
-                  Translationvector.x[j] -= 1.;
+                  Translationvector[j] -= 1.;
                 else
-                  Translationvector.x[j] += 1.;
+                  Translationvector[j] += 1.;
               }
             }
         }
-        Testvector.AddVector(&Translationvector);
+        Testvector += Translationvector;
         Testvector.MatrixMultiplication(matrix);
-        Center.AddVector(&Testvector);
-        Log() << Verbose(1) << "vector is: ";
-        Testvector.Output();
-        Log() << Verbose(0) << endl;
+        Center += Testvector;
+        Log() << Verbose(1) << "vector is: " << Testvector << endl;
 #ifdef ADDHYDROGEN
         // now also change all hydrogens
         for (BondList::const_iterator Runner = Walker->ListOfBonds.begin(); Runner != Walker->ListOfBonds.end(); (++Runner)) {
           if ((*Runner)->GetOtherAtom(Walker)->type->Z == 1) {
-            Testvector.CopyVector(&(*Runner)->GetOtherAtom(Walker)->x);
+            Testvector = (*Runner)->GetOtherAtom(Walker)->x;
             Testvector.MatrixMultiplication(inversematrix);
-            Testvector.AddVector(&Translationvector);
+            Testvector += Translationvector;
             Testvector.MatrixMultiplication(matrix);
-            Center.AddVector(&Testvector);
-            Log() << Verbose(1) << "Hydrogen vector is: ";
-            Testvector.Output();
-            Log() << Verbose(0) << endl;
+            Center += Testvector;
+            Log() << Verbose(1) << "Hydrogen vector is: " << Testvector << endl;
           }
         }
@@ -333,25 +338,24 @@
   while (ptr->next != end) {
     ptr = ptr->next;
-    Vector x;
-    x.CopyVector(&ptr->x);
+    Vector x = ptr->x;
     //x.SubtractVector(CenterOfGravity);
-    InertiaTensor[0] += ptr->type->mass*(x.x[1]*x.x[1] + x.x[2]*x.x[2]);
-    InertiaTensor[1] += ptr->type->mass*(-x.x[0]*x.x[1]);
-    InertiaTensor[2] += ptr->type->mass*(-x.x[0]*x.x[2]);
-    InertiaTensor[3] += ptr->type->mass*(-x.x[1]*x.x[0]);
-    InertiaTensor[4] += ptr->type->mass*(x.x[0]*x.x[0] + x.x[2]*x.x[2]);
-    InertiaTensor[5] += ptr->type->mass*(-x.x[1]*x.x[2]);
-    InertiaTensor[6] += ptr->type->mass*(-x.x[2]*x.x[0]);
-    InertiaTensor[7] += ptr->type->mass*(-x.x[2]*x.x[1]);
-    InertiaTensor[8] += ptr->type->mass*(x.x[0]*x.x[0] + x.x[1]*x.x[1]);
+    InertiaTensor[0] += ptr->type->mass*(x[1]*x[1] + x[2]*x[2]);
+    InertiaTensor[1] += ptr->type->mass*(-x[0]*x[1]);
+    InertiaTensor[2] += ptr->type->mass*(-x[0]*x[2]);
+    InertiaTensor[3] += ptr->type->mass*(-x[1]*x[0]);
+    InertiaTensor[4] += ptr->type->mass*(x[0]*x[0] + x[2]*x[2]);
+    InertiaTensor[5] += ptr->type->mass*(-x[1]*x[2]);
+    InertiaTensor[6] += ptr->type->mass*(-x[2]*x[0]);
+    InertiaTensor[7] += ptr->type->mass*(-x[2]*x[1]);
+    InertiaTensor[8] += ptr->type->mass*(x[0]*x[0] + x[1]*x[1]);
   }
   // print InertiaTensor for debugging
-  Log() << Verbose(0) << "The inertia tensor is:" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "The inertia tensor is:" << endl);
   for(int i=0;i<NDIM;i++) {
     for(int j=0;j<NDIM;j++)
-      Log() << Verbose(0) << InertiaTensor[i*NDIM+j] << " ";
-    Log() << Verbose(0) << endl;
-  }
-  Log() << Verbose(0) << endl;
+      DoLog(0) && (Log() << Verbose(0) << InertiaTensor[i*NDIM+j] << " ");
+    DoLog(0) && (Log() << Verbose(0) << endl);
+  }
+  DoLog(0) && (Log() << Verbose(0) << endl);
 
   // diagonalize to determine principal axis system
@@ -365,14 +369,14 @@
 
   for(int i=0;i<NDIM;i++) {
-    Log() << Verbose(1) << "eigenvalue = " << gsl_vector_get(eval, i);
-    Log() << Verbose(0) << ", eigenvector = (" << evec->data[i * evec->tda + 0] << "," << evec->data[i * evec->tda + 1] << "," << evec->data[i * evec->tda + 2] << ")" << endl;
+    DoLog(1) && (Log() << Verbose(1) << "eigenvalue = " << gsl_vector_get(eval, i));
+    DoLog(0) && (Log() << Verbose(0) << ", eigenvector = (" << evec->data[i * evec->tda + 0] << "," << evec->data[i * evec->tda + 1] << "," << evec->data[i * evec->tda + 2] << ")" << endl);
   }
 
   // check whether we rotate or not
   if (DoRotate) {
-    Log() << Verbose(1) << "Transforming molecule into PAS ... ";
+    DoLog(1) && (Log() << Verbose(1) << "Transforming molecule into PAS ... ");
     // the eigenvectors specify the transformation matrix
     ActOnAllVectors( &Vector::MatrixMultiplication, (const double *) evec->data );
-    Log() << Verbose(0) << "done." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "done." << endl);
 
     // summing anew for debugging (resulting matrix has to be diagonal!)
@@ -385,25 +389,24 @@
     while (ptr->next != end) {
       ptr = ptr->next;
-      Vector x;
-      x.CopyVector(&ptr->x);
+      Vector x = ptr->x;
       //x.SubtractVector(CenterOfGravity);
-      InertiaTensor[0] += ptr->type->mass*(x.x[1]*x.x[1] + x.x[2]*x.x[2]);
-      InertiaTensor[1] += ptr->type->mass*(-x.x[0]*x.x[1]);
-      InertiaTensor[2] += ptr->type->mass*(-x.x[0]*x.x[2]);
-      InertiaTensor[3] += ptr->type->mass*(-x.x[1]*x.x[0]);
-      InertiaTensor[4] += ptr->type->mass*(x.x[0]*x.x[0] + x.x[2]*x.x[2]);
-      InertiaTensor[5] += ptr->type->mass*(-x.x[1]*x.x[2]);
-      InertiaTensor[6] += ptr->type->mass*(-x.x[2]*x.x[0]);
-      InertiaTensor[7] += ptr->type->mass*(-x.x[2]*x.x[1]);
-      InertiaTensor[8] += ptr->type->mass*(x.x[0]*x.x[0] + x.x[1]*x.x[1]);
+      InertiaTensor[0] += ptr->type->mass*(x[1]*x[1] + x[2]*x[2]);
+      InertiaTensor[1] += ptr->type->mass*(-x[0]*x[1]);
+      InertiaTensor[2] += ptr->type->mass*(-x[0]*x[2]);
+      InertiaTensor[3] += ptr->type->mass*(-x[1]*x[0]);
+      InertiaTensor[4] += ptr->type->mass*(x[0]*x[0] + x[2]*x[2]);
+      InertiaTensor[5] += ptr->type->mass*(-x[1]*x[2]);
+      InertiaTensor[6] += ptr->type->mass*(-x[2]*x[0]);
+      InertiaTensor[7] += ptr->type->mass*(-x[2]*x[1]);
+      InertiaTensor[8] += ptr->type->mass*(x[0]*x[0] + x[1]*x[1]);
     }
     // print InertiaTensor for debugging
-    Log() << Verbose(0) << "The inertia tensor is:" << endl;
+    DoLog(0) && (Log() << Verbose(0) << "The inertia tensor is:" << endl);
     for(int i=0;i<NDIM;i++) {
       for(int j=0;j<NDIM;j++)
-        Log() << Verbose(0) << InertiaTensor[i*NDIM+j] << " ";
-      Log() << Verbose(0) << endl;
-    }
-    Log() << Verbose(0) << endl;
+        DoLog(0) && (Log() << Verbose(0) << InertiaTensor[i*NDIM+j] << " ");
+      DoLog(0) && (Log() << Verbose(0) << endl);
+    }
+    DoLog(0) && (Log() << Verbose(0) << endl);
   }
 
@@ -423,55 +426,52 @@
   double alpha, tmp;
   Vector z_axis;
-  z_axis.x[0] = 0.;
-  z_axis.x[1] = 0.;
-  z_axis.x[2] = 1.;
+  z_axis[0] = 0.;
+  z_axis[1] = 0.;
+  z_axis[2] = 1.;
 
   // rotate on z-x plane
-  Log() << Verbose(0) << "Begin of Aligning all atoms." << endl;
-  alpha = atan(-n->x[0]/n->x[2]);
-  Log() << Verbose(1) << "Z-X-angle: " << alpha << " ... ";
+  DoLog(0) && (Log() << Verbose(0) << "Begin of Aligning all atoms." << endl);
+  alpha = atan(-n->at(0)/n->at(2));
+  DoLog(1) && (Log() << Verbose(1) << "Z-X-angle: " << alpha << " ... ");
   while (ptr->next != end) {
     ptr = ptr->next;
-    tmp = ptr->x.x[0];
-    ptr->x.x[0] =  cos(alpha) * tmp + sin(alpha) * ptr->x.x[2];
-    ptr->x.x[2] = -sin(alpha) * tmp + cos(alpha) * ptr->x.x[2];
+    tmp = ptr->x[0];
+    ptr->x[0] =  cos(alpha) * tmp + sin(alpha) * ptr->x[2];
+    ptr->x[2] = -sin(alpha) * tmp + cos(alpha) * ptr->x[2];
     for (int j=0;j<MDSteps;j++) {
-      tmp = ptr->Trajectory.R.at(j).x[0];
-      ptr->Trajectory.R.at(j).x[0] =  cos(alpha) * tmp + sin(alpha) * ptr->Trajectory.R.at(j).x[2];
-      ptr->Trajectory.R.at(j).x[2] = -sin(alpha) * tmp + cos(alpha) * ptr->Trajectory.R.at(j).x[2];
+      tmp = ptr->Trajectory.R.at(j)[0];
+      ptr->Trajectory.R.at(j)[0] =  cos(alpha) * tmp + sin(alpha) * ptr->Trajectory.R.at(j)[2];
+      ptr->Trajectory.R.at(j)[2] = -sin(alpha) * tmp + cos(alpha) * ptr->Trajectory.R.at(j)[2];
     }
   }
   // rotate n vector
-  tmp = n->x[0];
-  n->x[0] =  cos(alpha) * tmp +  sin(alpha) * n->x[2];
-  n->x[2] = -sin(alpha) * tmp +  cos(alpha) * n->x[2];
-  Log() << Verbose(1) << "alignment vector after first rotation: ";
-  n->Output();
-  Log() << Verbose(0) << endl;
+  tmp = n->at(0);
+  n->at(0) =  cos(alpha) * tmp +  sin(alpha) * n->at(2);
+  n->at(2) = -sin(alpha) * tmp +  cos(alpha) * n->at(2);
+  DoLog(1) && (Log() << Verbose(1) << "alignment vector after first rotation: " << n << endl);
 
   // rotate on z-y plane
   ptr = start;
-  alpha = atan(-n->x[1]/n->x[2]);
-  Log() << Verbose(1) << "Z-Y-angle: " << alpha << " ... ";
+  alpha = atan(-n->at(1)/n->at(2));
+  DoLog(1) && (Log() << Verbose(1) << "Z-Y-angle: " << alpha << " ... ");
   while (ptr->next != end) {
     ptr = ptr->next;
-    tmp = ptr->x.x[1];
-    ptr->x.x[1] =  cos(alpha) * tmp + sin(alpha) * ptr->x.x[2];
-    ptr->x.x[2] = -sin(alpha) * tmp + cos(alpha) * ptr->x.x[2];
+    tmp = ptr->x[1];
+    ptr->x[1] =  cos(alpha) * tmp + sin(alpha) * ptr->x[2];
+    ptr->x[2] = -sin(alpha) * tmp + cos(alpha) * ptr->x[2];
     for (int j=0;j<MDSteps;j++) {
-      tmp = ptr->Trajectory.R.at(j).x[1];
-      ptr->Trajectory.R.at(j).x[1] =  cos(alpha) * tmp + sin(alpha) * ptr->Trajectory.R.at(j).x[2];
-      ptr->Trajectory.R.at(j).x[2] = -sin(alpha) * tmp + cos(alpha) * ptr->Trajectory.R.at(j).x[2];
+      tmp = ptr->Trajectory.R.at(j)[1];
+      ptr->Trajectory.R.at(j)[1] =  cos(alpha) * tmp + sin(alpha) * ptr->Trajectory.R.at(j)[2];
+      ptr->Trajectory.R.at(j)[2] = -sin(alpha) * tmp + cos(alpha) * ptr->Trajectory.R.at(j)[2];
     }
   }
   // rotate n vector (for consistency check)
-  tmp = n->x[1];
-  n->x[1] =  cos(alpha) * tmp +  sin(alpha) * n->x[2];
-  n->x[2] = -sin(alpha) * tmp +  cos(alpha) * n->x[2];
-
-  Log() << Verbose(1) << "alignment vector after second rotation: ";
-  n->Output();
-  Log() << Verbose(1) << endl;
-  Log() << Verbose(0) << "End of Aligning all atoms." << endl;
+  tmp = n->at(1);
+  n->at(1) =  cos(alpha) * tmp +  sin(alpha) * n->at(2);
+  n->at(2) = -sin(alpha) * tmp +  cos(alpha) * n->at(2);
+
+
+  DoLog(1) && (Log() << Verbose(1) << "alignment vector after second rotation: " << n << endl);
+  DoLog(0) && (Log() << Verbose(0) << "End of Aligning all atoms." << endl);
 };
 
@@ -490,21 +490,19 @@
 
   // initialize vectors
-  a.x[0] = gsl_vector_get(x,0);
-  a.x[1] = gsl_vector_get(x,1);
-  a.x[2] = gsl_vector_get(x,2);
-  b.x[0] = gsl_vector_get(x,3);
-  b.x[1] = gsl_vector_get(x,4);
-  b.x[2] = gsl_vector_get(x,5);
+  a[0] = gsl_vector_get(x,0);
+  a[1] = gsl_vector_get(x,1);
+  a[2] = gsl_vector_get(x,2);
+  b[0] = gsl_vector_get(x,3);
+  b[1] = gsl_vector_get(x,4);
+  b[2] = gsl_vector_get(x,5);
   // go through all atoms
   while (ptr != par->mol->end) {
     ptr = ptr->next;
     if (ptr->type == ((struct lsq_params *)params)->type) { // for specific type
-      c.CopyVector(&ptr->x);  // copy vector to temporary one
-      c.SubtractVector(&a);   // subtract offset vector
-      t = c.ScalarProduct(&b);           // get direction parameter
-      d.CopyVector(&b);       // and create vector
-      d.Scale(&t);
-      c.SubtractVector(&d);   // ... yielding distance vector
-      res += d.ScalarProduct((const Vector *)&d);        // add squared distance
+      c = ptr->x - a;
+      t = c.ScalarProduct(b);           // get direction parameter
+      d = t*b;       // and create vector
+      c -= d;   // ... yielding distance vector
+      res += d.ScalarProduct(d);        // add squared distance
     }
   }
